Subject: [MMUSIC] Transport tags

From: Roman Shpount <[email-masked]>
Date: Wed, 11 Jan 2017 16:01:29 -0500

What should we use for the new protocols that we are defining?

Should it be UDP/TLS/SCTP or UDP/DTLS/SCTP?
Should it be UDP/TLS/BFCP or UDP/DTLS/BFCP?

I would like to see some consistency here.

Regards,
_____________
Roman Shpount

On Wed, Jan 11, 2017 at 3:30 AM, Magnus Westerlund <
[email-masked]> wrote:

> Den 2017-01-10 kl. 19:08, skrev Roman Shpount:
>
> P.S. In the quoted text someone mentioned "UDP/TLS/RTP/SAVPF", should it
>> be "UDP/DTLS/RTP/SAVPF"?
>>
>
> No, actually UDP/TLS/RTP/SAVPF is what is registered for DTLS-SRTP over
> UDP with RTP SAVPF profile. See [RFC5764]. The "UDP/DTLS/RTP/SAVPF" is not
> registered.
>
> So the alternatives for the dependency of default candidate protocol type
> in your proposal would be:
>
> UDP: "UDP/TLS/RTP/SAVPF"
> TCP: "TCP/DTLS/RTP/SAVPF"
>
>
> Cheers
>
> Magnus Westerlund
>
> ----------------------------------------------------------------------
> Services, Media and Network features, Ericsson Research EAB/TXM
> ----------------------------------------------------------------------
> Ericsson AB                 | Phone  +46 10 7148287
> Färögatan 6                 | Mobile +46 73 0949079
> SE-164 80 Stockholm, Sweden | mailto: [email-masked]
> ----------------------------------------------------------------------
>
>

---

From: "Charles Eckel (eckelcu)" <[email-masked]>
Date: Wed, 11 Jan 2017 22:05:40 +0000

Here is what we have for BFCP in https://tools.ietf.org/html/draft-ietf-bfcpbis-rfc4583bis-16#section-13:

                       +--------------+------------+
                       | Value        | Reference  |
                       +--------------+------------+
                       | TCP/BFCP     | [RFC XXXX] |
                       | TCP/TLS/BFCP | [RFC XXXX] |
                       | UDP/BFCP     | [RFC XXXX] |
                       | UDP/TLS/BFCP | [RFC XXXX] |
                       +--------------+------------+

Cheers,
Charles

From: mmusic <[email-masked]> on behalf of Roman Shpount <[email-masked]>
Date: Wednesday, January 11, 2017 at 1:01 PM
To: Magnus Westerlund <[email-masked]>
Cc: Paul Kyzivat <[email-masked]>, "[email-masked]" <[email-masked]>
Subject: [MMUSIC] Transport tags

Regards,
_____________
Roman Shpount

On Wed, Jan 11, 2017 at 3:30 AM, Magnus Westerlund <[email-masked]<mailto:[email-masked]>> wrote:
Den 2017-01-10 kl. 19:08, skrev Roman Shpount:
P.S. In the quoted text someone mentioned "UDP/TLS/RTP/SAVPF", should it
be "UDP/DTLS/RTP/SAVPF"?

No, actually UDP/TLS/RTP/SAVPF is what is registered for DTLS-SRTP over UDP with RTP SAVPF profile. See [RFC5764]. The "UDP/DTLS/RTP/SAVPF" is not registered.

So the alternatives for the dependency of default candidate protocol type in your proposal would be:

UDP: "UDP/TLS/RTP/SAVPF"

Cheers

Magnus Westerlund

----------------------------------------------------------------------
Services, Media and Network features, Ericsson Research EAB/TXM
----------------------------------------------------------------------
Ericsson AB                 | Phone  +46 10 7148287<tel:%2B46%2010%207148287>
Färögatan 6                 | Mobile +46 73 0949079<tel:%2B46%2073%200949079>
SE-164 80 Stockholm, Sweden | mailto: [email-masked]<mailto:[email-masked]>
----------------------------------------------------------------------

---

From: Roman Shpount <[email-masked]>
Date: Wed, 11 Jan 2017 19:33:13 -0500

I guess BFCP will need TCP/DTLS/BFCP added to the list.

Should we correct draft-ietf-mmusic-sctp-sdp draft to match and change
UDP/DTLS/SCTP to UDP/TLS/SCTP?

Regards,

_____________
Roman Shpount

On Wed, Jan 11, 2017 at 5:05 PM, Charles Eckel (eckelcu) <[email-masked]>
wrote:

> Here is what we have for BFCP in https://tools.ietf.org/html/
> draft-ietf-bfcpbis-rfc4583bis-16#section-13:
>
>
>
> *From: *mmusic <[email-masked]> on behalf of Roman Shpount <
> [email-masked]>
> *Date: *Wednesday, January 11, 2017 at 1:01 PM
> *To: *Magnus Westerlund <[email-masked]>
> *Cc: *Paul Kyzivat <[email-masked]>, "[email-masked]" <
> [email-masked]>
> *Subject: *[MMUSIC] Transport tags
>
>
>

---

From: Magnus Westerlund <[email-masked]>
Date: Thu, 12 Jan 2017 08:48:35 +0100

Hi,

I think one should actually use the DTLS or TLS depending on what one 
requires. It one requires DTLS, then use DTLS, if is working with plain 
TLS, then use TLS. The UDP/TLS/RTP/SAVPF is part of the first DTLS-SRTP 
registrations that was done. As plain TLS can't work in this particular 
combination due to UDP there is no actual risk for having to seperate 
between TLS and DTLS. However, if one stack is TCP/FRAMING/(D)TLS/FOO 
then there are potentially important differences if this is TLS or DTLS.

Cheers

Magnus

Den 2017-01-11 kl. 22:01, skrev Roman Shpount:
> On Wed, Jan 11, 2017 at 3:30 AM, Magnus Westerlund
> <[email-masked] <mailto:[email-masked]>>
> wrote:
>
>     No, actually UDP/TLS/RTP/SAVPF is what is registered for DTLS-SRTP
>     over UDP with RTP SAVPF profile. See [RFC5764]. The
>     "UDP/DTLS/RTP/SAVPF" is not registered.
>
>     <tel:%2B46%2010%207148287>
>     <tel:%2B46%2073%200949079>
>     <mailto:[email-masked]>

-- 

Magnus Westerlund

---

From: "Charles Eckel (eckelcu)" <[email-masked]>
Date: Thu, 12 Jan 2017 15:51:56 +0000

Works for me.

Cheers,
Charles

From: Roman Shpount <[email-masked]>
Date: Wednesday, January 11, 2017 at 4:33 PM
To: Charles Eckel <[email-masked]>
Cc: Magnus Westerlund <[email-masked]>, Paul Kyzivat <[email-masked]>, "[email-masked]" <[email-masked]>, Christer Holmberg <[email-masked]>
Subject: Re: [MMUSIC] Transport tags

Should we correct draft-ietf-mmusic-sctp-sdp draft to match and change UDP/DTLS/SCTP to UDP/TLS/SCTP?

Regards,

_____________
Roman Shpount

On Wed, Jan 11, 2017 at 5:05 PM, Charles Eckel (eckelcu) <[email-masked]<mailto:[email-masked]>> wrote:
Here is what we have for BFCP in https://tools.ietf.org/html/draft-ietf-bfcpbis-rfc4583bis-16#section-13:

Cheers,
Charles

From: mmusic <[email-masked]<mailto:[email-masked]>> on behalf of Roman Shpount <[email-masked]<mailto:[email-masked]>>
Date: Wednesday, January 11, 2017 at 1:01 PM
To: Magnus Westerlund <[email-masked]<mailto:[email-masked]>>
Cc: Paul Kyzivat <[email-masked]<mailto:[email-masked]>>, "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>
Subject: [MMUSIC] Transport tags

Regards,
_____________
Roman Shpount

UDP: "UDP/TLS/RTP/SAVPF"

Cheers

Magnus Westerlund

---

From: Roman Shpount <[email-masked]>
Date: Thu, 12 Jan 2017 10:56:44 -0500

Magnus,

Does it mean for the future protocols we should do DTLS? As
in UDP/DTLS/BFCP and UDP/DTLS/SCTP?

And we should consider UDP/TLS/RTP as legacy that does not follow the
preferred rule.

Regards,

_____________
Roman Shpount

On Thu, Jan 12, 2017 at 2:48 AM, Magnus Westerlund <
[email-masked]> wrote:

> between TLS and DTLS. However, if one stack is TCP/FRAMING/(D)TLS/FOO then
> there are potentially important differences if this is TLS or DTLS.
>
> Cheers
>
> Magnus
>

---

From: Magnus Westerlund <[email-masked]>
Date: Thu, 12 Jan 2017 17:09:19 +0100

> in UDP/DTLS/BFCP and UDP/DTLS/SCTP?

Yes, I think so given that the protocol is DTLS and not TLS.

> And we should consider UDP/TLS/RTP as legacy that does not follow the

I would.

Cheers

Magnus Westerlund

---

From: Christer Holmberg <[email-masked]>
Date: Thu, 12 Jan 2017 20:34:35 +0000

Hi,

Now sure I follow: Where TCP with DTLS for BFCP defined? Doesn’t TCP based BFCP run over TLS?

That is also what is used in RFC 4583.

As Roman has indicated, TCP/BFCP and TLS/BFCP won’t work on ICE. But, if you want to fix, don’t you then have to do more than just change the m- proto value? Don’t you have to define usage of the framing mechanism?

Regards,

Christer

From: Charles Eckel (eckelcu) [mailto:[email-masked]]
Sent: 12 January 2017 17:52
To: Roman Shpount <[email-masked]>
Cc: Magnus Westerlund <[email-masked]>; Paul Kyzivat <[email-masked]>; [email-masked]; Christer Holmberg <[email-masked]>
Subject: Re: [MMUSIC] Transport tags

Works for me.

Cheers,
Charles

From: Roman Shpount <[email-masked]<mailto:[email-masked]>>
Date: Wednesday, January 11, 2017 at 4:33 PM
To: Charles Eckel <[email-masked]<mailto:[email-masked]>>
Cc: Magnus Westerlund <[email-masked]<mailto:[email-masked]>>, Paul Kyzivat <[email-masked]<mailto:[email-masked]>>, "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>, Christer Holmberg <[email-masked]<mailto:[email-masked]>>
Subject: Re: [MMUSIC] Transport tags

Regards,

_____________
Roman Shpount

Cheers,
Charles

Regards,
_____________
Roman Shpount

UDP: "UDP/TLS/RTP/SAVPF"

Cheers

Magnus Westerlund

---

From: Roman Shpount <[email-masked]>
Date: Thu, 12 Jan 2017 15:46:00 -0500

Hi Christer,

Definition for TCP/DTLS/BFCP needs to be added
in draft-ietf-bfcpbis-rfc4583bis.

This is BFCP over DTLS over TCP with RFC 4571 framing. UDP/DTLS/BFCP
together with TCP/DTLS/BFCP will over ICE based on the mechanisms defined
in draft-ietf-mmusic-dtls-sdp. Only UDP/DTLS/BFCP in combination with
TCP/DTLS/BFCP will support ICE. TCP/BFCP and TLS/BFCP will not support ICE
and will have two run with at least one end point on the public IP.

I hope it makes sense.

Regards,

_____________
Roman Shpount

On Thu, Jan 12, 2017 at 3:34 PM, Christer Holmberg <
[email-masked]> wrote:

> As Roman has indicated, TCP/BFCP and TLS/BFCP won’t work on ICE. But, if
> you want to fix, don’t you then have to do more than just change the m-
> proto value? Don’t you have to define usage of the framing mechanism?
>
>
>
> Regards,
>
>
>
> Christer
>
>
>
> *From:* Charles Eckel (eckelcu) [mailto:[email-masked]]
> *Sent:* 12 January 2017 17:52
> *To:* Roman Shpount <[email-masked]>
> *Cc:* Magnus Westerlund <[email-masked]>; Paul Kyzivat <
> [email-masked]>; [email-masked]; Christer Holmberg <
> [email-masked]>
>
> *Subject:* Re: [MMUSIC] Transport tags
>
>
>
> Works for me.
>
>
>
> Cheers,
>
> Charles
>
>
>
> *From: *Roman Shpount <[email-masked]>
> *Date: *Wednesday, January 11, 2017 at 4:33 PM
> *To: *Charles Eckel <[email-masked]>
> *Cc: *Magnus Westerlund <[email-masked]>, Paul Kyzivat <
> [email-masked]>, "[email-masked]" <[email-masked]>, Christer
> Holmberg <[email-masked]>
> *Subject: *Re: [MMUSIC] Transport tags
>
>
>
> On Wed, Jan 11, 2017 at 5:05 PM, Charles Eckel (eckelcu) <
> [email-masked]> wrote:
>

---

From: Christer Holmberg <[email-masked]>
Date: Thu, 12 Jan 2017 21:08:57 +0000

Hi,

>Definition for TCP/DTLS/BFCP needs to be added in draft-ietf-bfcpbis-rfc4583bis.
>
>This is BFCP over DTLS over TCP with RFC 4571 framing.

Correct.

>UDP/DTLS/BFCP together with TCP/DTLS/BFCP will over ICE based on the mechanisms defined in draft-ietf-mmusic-dtls-sdp. Only UDP/DTLS/BFCP >in combination with TCP/DTLS/BFCP will support ICE. TCP/BFCP and TLS/BFCP will not support ICE and will have two run with at least one end point >on the public IP.

I agree with all of that, but that was not my issue :)

My issue was that it is not enough to simply change the proto value in 4583bis. You also need to define the usage of the RFC 4571 framing mechanism.

And, if that is not backward compatible with RFC 4583 (which does NOT use 4571 framing), you need to add some text about that also.

Regards,

Christer

_____________
Roman Shpount

On Thu, Jan 12, 2017 at 3:34 PM, Christer Holmberg <[email-masked]<mailto:[email-masked]>> wrote:
Hi,

Regards,

Christer

From: Charles Eckel (eckelcu) [mailto:[email-masked]<mailto:[email-masked]>]
Sent: 12 January 2017 17:52
To: Roman Shpount <[email-masked]<mailto:[email-masked]>>
Cc: Magnus Westerlund <[email-masked]<mailto:[email-masked]>>; Paul Kyzivat <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; Christer Holmberg <[email-masked]<mailto:[email-masked]>>

Works for me.

Cheers,
Charles

Regards,

_____________
Roman Shpount

Cheers,
Charles

Regards,
_____________
Roman Shpount

UDP: "UDP/TLS/RTP/SAVPF"

Cheers

Magnus Westerlund

---

From: Roman Shpount <[email-masked]>
Date: Thu, 12 Jan 2017 16:27:57 -0500

On Thu, Jan 12, 2017 at 4:08 PM, Christer Holmberg <
[email-masked]> wrote:

> >UDP/DTLS/BFCP together with TCP/DTLS/BFCP will over ICE based on the
> mechanisms defined in draft-ietf-mmusic-dtls-sdp. Only UDP/DTLS/BFCP >in
> combination with TCP/DTLS/BFCP will support ICE. TCP/BFCP and TLS/BFCP will
> not support ICE and will have two run with at least one end point >on the
> public IP.
>
>
>
> My issue was that it is not enough to simply change the proto value in
> 4583bis. You also need to define the usage of the RFC 4571 framing
> mechanism.
>
>
>
> And, if that is not backward compatible with RFC 4583 (which does NOT use
> 4571 framing), you need to add some text about that also.
>
>
>
I do not think TCP/DTLS/BFCP is defined anywhere, so it does not have to be
backwards compatible. We are not changing the proto value, we should define
a new one and explain how it works. This leaves TCP/BFCP and TLS/BFCP as
they were previously defined and simply states that these transports cannot
be used with ICE. Only UDP/DTLS/BFCP and TCP/DTLS/BFCP can be used with
ICE, with ICE not supported for all the other BFCP flavors.

Only issue I see here is that an offer of BFCP with ICE will not be
backwards compatible with RFC 4583 implementations, but considering that
RFC4583 did not define BFCP over DTLS at all, we should be fine here.

Regards,
_____________
Roman Shpount

---

From: Christer Holmberg <[email-masked]>
Date: Thu, 12 Jan 2017 21:45:01 +0000

Hi,

…

>I do not think TCP/DTLS/BFCP is defined anywhere, so it does not have to be backwards compatible. We are not changing the proto value, we should >define a new one and explain how it works. This leaves TCP/BFCP and TLS/BFCP as they were previously defined and simply states that these transports >cannot be used with ICE. Only UDP/DTLS/BFCP and TCP/DTLS/BFCP can be used with ICE, with ICE not supported for all the other BFCP flavors.

Ok, so TCP/BFCP and TLS/BFCP will still be kept in 4583bis, and should be used when ICE is not used?

Regards,

Christer

---

From: Roman Shpount <[email-masked]>
Date: Thu, 12 Jan 2017 17:15:03 -0500

On Thu, Jan 12, 2017 at 4:45 PM, Christer Holmberg <
[email-masked]> wrote:

> >I do not think TCP/DTLS/BFCP is defined anywhere, so it does not have to
> be backwards compatible. We are not changing the proto value, we should
> >define a new one and explain how it works. This leaves TCP/BFCP and
> TLS/BFCP as they were previously defined and simply states that these
> transports >cannot be used with ICE. Only UDP/DTLS/BFCP and TCP/DTLS/BFCP
> can be used with ICE, with ICE not supported for all the other BFCP
> flavors.
>
>
>
TCP/BFCP, TLS/BFCP and UDP/BFCP will be kept in 4583bis and can only be
used when ICE is not used. UDP/DTLS/BFCP and TCP/DTLS/BFCP are two
transport that can be used with or without ICE.

Regards,
_____________
Roman Shpount

---

From: Magnus Westerlund <[email-masked]>
Date: Fri, 13 Jan 2017 09:35:29 +0100

Hi,

A question, is the UDP/DTLS/BFCP only used with ICE, or are they also 
used without ICE support. I wonders how this relates to the discussion 
that the UDP/TCP destinction becomes mote when one actually are doing 
ICE/DTLS/BFCP, i.e. use ICE to agree on a datagram capable transport and 
then puts DTLS/BFCP over it, independent on what transport type the 
arrived candidate pairs are on.

Is there a point to the BFCP usages to actually be explicit that we one 
only want to use ICE negotiated DTLS secured BFCP, and thus should have 
a PROTO value for that, i.e. ICE/DTLS/BFCP?

Note, this is a question, not an actual proposal. Just an exploration so 
that you who use the protocol can consider if it makes sense.

Cheers

Magnus

Den 2017-01-12 kl. 23:15, skrev Roman Shpount:
> On Thu, Jan 12, 2017 at 4:45 PM, Christer Holmberg
> <[email-masked] <mailto:[email-masked]>>
> wrote:
>
>     >I do not think TCP/DTLS/BFCP is defined anywhere, so it does not
>     have to be backwards compatible. We are not changing the proto
>     value, we should >define a new one and explain how it works. This
>     leaves TCP/BFCP and TLS/BFCP as they were previously defined and
>     simply states that these transports >cannot be used with ICE. Only
>     UDP/DTLS/BFCP and TCP/DTLS/BFCP can be used with ICE, with ICE not
>     supported for all the other BFCP flavors.
>
>     __
>
>     __ __
>
>     Ok, so TCP/BFCP and TLS/BFCP will still be kept in 4583bis, and
>     should be used when ICE is not used?____
>
>
>

-- 

Magnus Westerlund

---

From: Christer Holmberg <[email-masked]>
Date: Fri, 13 Jan 2017 08:41:58 +0000

Hi,

I see no reason to use UDP/DTLS/BFCP only with ICE.

The question to define an ³ICE proto² has came up before. It¹s certainly
an interesting idea, but I think it should be studied within a wider scope
- not for a specific protocol.

Regards,

Christer

---

From: "Charles Eckel (eckelcu)" <[email-masked]>
Date: Fri, 13 Jan 2017 14:24:42 +0000

UDP/DTLS/BFCP is already defined in 4583bis, except we specified the tag as UDP/TLS/BFCP. I agree it can be used with and without ICE.

Cheers,
Charles

On Jan 12, 2017, at 2:15 PM, Roman Shpount <[email-masked]<mailto:[email-masked]>> wrote:

TCP/BFCP, TLS/BFCP and UDP/BFCP will be kept in 4583bis and can only be used when ICE is not used. UDP/DTLS/BFCP and TCP/DTLS/BFCP are two transport that can be used with or without ICE.

Regards,
_____________
Roman Shpount

---

From: "Charles Eckel (eckelcu)" <[email-masked]>
Date: Fri, 13 Jan 2017 14:28:24 +0000

It is possible and people already do use UDP/TLS/BFCP with ICE and without any TCP candidates. 

Cheers,
Charles

> On Jan 13, 2017, at 12:35 AM, Magnus Westerlund <[email-masked]> wrote:
> 
> Hi,
> 
> A question, is the UDP/DTLS/BFCP only used with ICE, or are they also used without ICE support. I wonders how this relates to the discussion that the UDP/TCP destinction becomes mote when one actually are doing ICE/DTLS/BFCP, i.e. use ICE to agree on a datagram capable transport and then puts DTLS/BFCP over it, independent on what transport type the arrived candidate pairs are on.
> 
> Is there a point to the BFCP usages to actually be explicit that we one only want to use ICE negotiated DTLS secured BFCP, and thus should have a PROTO value for that, i.e. ICE/DTLS/BFCP?
> 
> Note, this is a question, not an actual proposal. Just an exploration so that you who use the protocol can consider if it makes sense.
> 
> Cheers
> 
> Magnus
>